#include "data.h"
#include "lsmres.h"
#include <stdio.h>

#define SETCHECK(i,t) SendMessage(GetDlgItem(hwnd,i),BM_SETCHECK,\
	(WPARAM)(t?BST_CHECKED:BST_UNCHECKED),(LPARAM)0)

#define TESTCHECK(i) (SendMessage(GetDlgItem(hwnd,i),BM_GETCHECK,\
	(WPARAM)0,(LPARAM)0)==BST_CHECKED)

extern HWND hwndMain;
extern matrix IDENTITY;
extern MYPTR  HighItem;
extern char InputBuffer[];
extern HINSTANCE hInst;
extern PPROJECT ActiveProject;
extern short HighType;

int m_id[12]={
	EB_VECXX,EB_VECXY,EB_VECXZ,
	EB_VECYX,EB_VECYY,EB_VECYZ,
	EB_VECZX,EB_VECZY,EB_VECZZ,
	EB_VECLX,EB_VECLY,EB_VECLZ
};

COLORREF colors[16];

CHOOSECOLOR cc= {
	sizeof(CHOOSECOLOR),
	NULL,NULL,
	RGB(128,128,128),
	colors,
	CC_RGBINIT,
	(LPARAM)0,
	NULL,
	NULL} ;

void SetDlgItemFloat(HWND hwnd,int DlgItem,float Val) {
	char numBuff[20];
	sprintf(numBuff,"%g",Val);
	SetDlgItemText(hwnd,DlgItem,numBuff);
}

float GetDlgItemFloat(HWND hwnd,int DlgItem) {
	char numBuff[20];
	GetDlgItemText(hwnd,DlgItem,numBuff,20);
	numBuff[19]=0;
	return atof(numBuff);
}

BOOL _stdcall AboutDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	switch(msg) {
		case WM_CLOSE:
			EndDialog(hwnd,0);
			return 1;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDOK:
					EndDialog(hwnd,1);
					return 1;
			}
			break;
	}
	return 0;
}

BOOL _stdcall EditPartDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	static PDLGX idlgx;
	static part *p;

//	short i;
	switch(msg) {
		case WM_INITDIALOG:
			idlgx=(PDLGX)lParam;
			InitializeDialogData(hwnd,idlgx);
			p=(part*)GetDialogObject(idlgx);
		return TRUE;
		case WM_CLOSE:
			EndDialog(hwnd,0);
			return 1;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDRETRY:
					InitializeDialogData(hwnd,idlgx);
				return TRUE;
				case IDOK:
					GetDlgItemText(hwnd,EB_NAME,InputBuffer,63);
					if(IsUniquePartName((PMODEL)ActiveProject,InputBuffer,p)==FALSE) {
						MessageBoxEx(hwnd,"There is already a part by that name.","Rejected",MB_OK,LANG_NEUTRAL);
						return TRUE;
					}
					ReturnDialogData(hwnd,idlgx);
				case IDCANCEL:
					EndDialog(hwnd,LOWORD(wParam));
				return 1;
			}
		break;
	}
	return 0;
}

BOOL _stdcall InputMatrixDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	static PDLGX idlgx;

	short i;
	switch(msg) {
		case WM_INITDIALOG:
			idlgx=(PDLGX)lParam;
			InitializeDialogData(hwnd,idlgx);
		return TRUE;
		case WM_CLOSE:
			EndDialog(hwnd,0);
			return 1;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case BB_PLAIN:
					for(i=0;i<12;i++)
					SetDlgItemFloat(hwnd,m_id[i],IDENTITY[i]);
				return TRUE;
				case IDRETRY:
					InitializeDialogData(hwnd,idlgx);
				return TRUE;
				case IDOK:
					ReturnDialogData(hwnd,idlgx);
				case IDCANCEL:
					EndDialog(hwnd,LOWORD(wParam));
				return 1;
			}
		break;
	}
	return 0;
}

// selects tint in the tint window

void SelectDialogTint(HWND hwnd,tint *t) {
	int i;

	for(i=0;i<SendDlgItemMessage(hwnd,LB_TINTLIST,LB_GETCOUNT,0,0);i++)
	if(t==(tint *)SendDlgItemMessage(hwnd,LB_TINTLIST,LB_GETITEMDATA,i,(LPARAM)0))
		SendDlgItemMessage(hwnd,LB_TINTLIST,LB_SETCURSEL,(WPARAM)i,(LPARAM)0);
}

BOOL _stdcall PickTintDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	static tint *t;
	int i;
	static face* f;
	switch(msg) {
		case WM_INITDIALOG:
// add all existing tints to the dialog box
			i=0;
			STEPTINTS(ActiveProject,t) {
				SendDlgItemMessage(hwnd,LB_TINTLIST,LB_ADDSTRING,0,(LPARAM)t->Name);
				SendDlgItemMessage(hwnd,LB_TINTLIST,LB_SETITEMDATA,i,(LPARAM)t);
				i++;
			}
			f=(face*)lParam;
			t=f->Texture;
// select the tint that is attached to the highlighted face
			SelectDialogTint(hwnd,t);
		return TRUE;
		case WM_DRAWITEM:
			TintWindow(GetDlgItem(hwnd,IMG_IMAGEBOX),t);
		return TRUE;
		case WM_CLOSE:
			EndDialog(hwnd,0);
		return TRUE;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case LB_TINTLIST:
					switch(HIWORD(wParam)){
						case LBN_SELCHANGE:
							i=SendDlgItemMessage(hwnd,LB_TINTLIST,LB_GETCURSEL,0,0);
							t=(tint *)SendDlgItemMessage(hwnd,LB_TINTLIST,LB_GETITEMDATA,i,0);
							InvalidateRect(hwnd,NULL,FALSE);
//							TintWindow(GetDlgItem(hwnd,IMG_IMAGEBOX),t);
						break;
					}
				return TRUE;
				case IDRETRY:
				return TRUE;
				case BB_ADD:
					t=CreateTint(NULL,0x808080,FALSE);
					if(DialogBoxParam(hInst,MAKEINTRESOURCE(DLG_EDITTINT),hwnd,EditTintDlg,
 						(int)t)==IDOK) {
						i=SendDlgItemMessage(hwnd,LB_TINTLIST,LB_GETCOUNT,0,0);

						SendDlgItemMessage(hwnd,LB_TINTLIST,LB_ADDSTRING,0,(LPARAM)t->Name);
						SendDlgItemMessage(hwnd,LB_TINTLIST,LB_SETITEMDATA,(WPARAM)i,(LPARAM)t);

						//highlight selection of added item
						SelectDialogTint(hwnd,t);
						t->hbm=(HBITMAP)0;
						t->bmBits=(GLubyte *)0;
						InvalidateRect(hwnd,NULL,FALSE);
//						TintWindow(GetDlgItem(hwnd,IMG_IMAGEBOX),t);
//						CreateTintDelta(t,DT_ADD);
					} else {
						DestroyTint(t,FALSE);
					}
				return TRUE;
				case BB_MODIFY:
					i=SendDlgItemMessage(hwnd,LB_TINTLIST,LB_GETCURSEL,0,0);
					if(i==LB_ERR) return TRUE; // if no item selected, no name to change

					t=(tint *)SendDlgItemMessage(hwnd,LB_TINTLIST,LB_GETITEMDATA,i,0);
					if(DialogBoxParam(hInst,MAKEINTRESOURCE(DLG_EDITTINT),hwnd,EditTintDlg,
 						(int)t)==IDOK) {
						SendDlgItemMessage(hwnd,LB_TINTLIST,LB_DELETESTRING,i,0);
						SendDlgItemMessage(hwnd,LB_TINTLIST,LB_INSERTSTRING,i,(LPARAM)t->Name);
						SendDlgItemMessage(hwnd,LB_TINTLIST,LB_SETITEMDATA,i,(LPARAM)t);
						SendDlgItemMessage(hwnd,LB_TINTLIST,LB_SETCURSEL,i,0);
						DeleteObject(t->hbm);
						t->hbm=(HBITMAP)0;
						t->bmBits=(GLubyte *)0;
						InvalidateRect(hwnd,NULL,FALSE);
//						TintWindow(GetDlgItem(hwnd,IMG_IMAGEBOX),t);
//						CreateTintDelta(t,DT_CHG);
					}
				return TRUE;

				case BB_DELETE:
					i=SendDlgItemMessage(hwnd,LB_TINTLIST,LB_GETCURSEL,0,0);
					if(i==LB_ERR) return TRUE; // if no item selected, no item to delete
					t=(tint*)SendDlgItemMessage(hwnd,LB_TINTLIST,LB_GETITEMDATA,i,0);
					if(t==((PMODEL)ActiveProject)->defTint) {
						MessageBoxEx(hwnd,"Cannot delete the default texture.","No!",MB_OK,LANG_NEUTRAL);
						return TRUE;
					}
					if(MessageBoxEx(hwnd,"This will remove this texture from every face that has it applied.  Continue?",
						"Warning",MB_OKCANCEL|MB_ICONWARNING,LANG_NEUTRAL)==IDOK) {

						if(((PMODEL)ActiveProject)->CurTint==t)
						((PMODEL)ActiveProject)->CurTint=((PMODEL)ActiveProject)->defTint;

						DestroyTint(t,FALSE);
						SendDlgItemMessage(hwnd,LB_TINTLIST,LB_DELETESTRING,i,0);
						t=((PMODEL)ActiveProject)->defTint;
						SelectDialogTint(hwnd,t);
						TintWindow(GetDlgItem(hwnd,IMG_IMAGEBOX),t);
					}
				return TRUE;
				case IDOK:
					i=SendDlgItemMessage(hwnd,LB_TINTLIST,LB_GETCURSEL,0,0);
					if(i!=LB_ERR) {
						t=(tint*)SendDlgItemMessage(hwnd,LB_TINTLIST,LB_GETITEMDATA,i,0);
						if(ActiveProject) ((PMODEL)ActiveProject)->CurTint=t;
						f->Texture=t;
//						CreateFaceDelta(f,DT_CHG);
					}
				case IDCANCEL:
//					AddAtomDelta(ActiveProject);
					EndDialog(hwnd,LOWORD(wParam));
					InvalidateView();
				return TRUE;
			}
		break;
	}
	return 0;
}

BOOL _stdcall EditTintDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	static tint *t;
	static COLORREF cr;
	char nameBuffer[256];

	switch(msg) {
		case WM_INITDIALOG:
			t=(tint *)lParam;
			SetDlgItemText(hwnd,EB_NAME,t->Name);
			SetDlgItemText(hwnd,EB_FILE,t->File);
			cr=t->color;
		return TRUE;
		case WM_DRAWITEM:
			FillWindow(GetDlgItem(hwnd,IMG_COLORBOX),cr);
		return TRUE;
		case WM_CLOSE:
			EndDialog(hwnd,0);
		return TRUE;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDRETRY:
					SetDlgItemText(hwnd,EB_NAME,t->Name);
					cr=t->color;
					FillWindow(GetDlgItem(hwnd,IMG_COLORBOX),cr);
				return TRUE;
				case BB_CHANGE:
					cc.hwndOwner=hwnd;
					cc.Flags|=CC_RGBINIT;
					cc.rgbResult=cr;
					if(ChooseColor(&cc)) cr=cc.rgbResult;
					FillWindow(GetDlgItem(hwnd,IMG_COLORBOX),cr);
				return 1;
				case BB_SELECT:
					GetBMPFileName(hwnd,EB_FILE);
				return TRUE;
				case IDOK:
					GetDlgItemText(hwnd,EB_NAME,nameBuffer,32);
					if(IsUniqueTintName((PMODEL)ActiveProject,nameBuffer,t)) {
						DestroyString(t->Name);
						t->Name=CloneString(nameBuffer);
					} else {
						MessageBoxEx(hwnd,"This texture name is already in use.","Rejected",MB_OK,LANG_NEUTRAL);
						return 1;
					}
					GetDlgItemText(hwnd,EB_FILE,nameBuffer,256);
					if(t->File) DestroyString(t->File);
					if(strlen(nameBuffer)) {
						t->File=CloneString(nameBuffer);
					} else {
						t->File=NULL;
					}

					t->color=cr;
					DeriveSolid(t);
// code here to replace bitmap of tint
				case IDCANCEL:
					EndDialog(hwnd,LOWORD(wParam));
				return 1;
			}
		break;
	}
	return 0;
}

void ReportSystemError(char *s) {
//	UpdateStatusBar(s,0,0);
	MessageBoxEx(hwndMain,s,"Guess what?",MB_OK,LANG_NEUTRAL);
}

void InitializeDialogData(HWND hwnd,PDLGX dd) {
	int i;

	for(i=1;i<=dd[0].item;i++)
	switch(dd[i].type) {
		case DXT_INT:
			SetDlgItemInt(hwnd,dd[i].item,dd[i].data.idata,TRUE);
		break;
		case DXT_TXT:
			SetDlgItemText(hwnd,dd[i].item,dd[i].data.tdata);
		break;
		case DXT_NUM:
			SetDlgItemFloat(hwnd,dd[i].item,dd[i].data.fdata);
		break;
		case DXT_VEC:
			SetDlgItemFloat(hwnd,dd[i].item+X,dd[i].data.vdata[X]);
			SetDlgItemFloat(hwnd,dd[i].item+Y,dd[i].data.vdata[Y]);
			SetDlgItemFloat(hwnd,dd[i].item+Z,dd[i].data.vdata[Z]);
		break;
		case DXT_TTL:
			SetWindowText(hwnd,dd[i].data.tdata);
		break;
		case DXT_FLG:
			CheckDlgButton(hwnd,dd[i].item,(dd[i].data.idata!=0)?BST_CHECKED:BST_UNCHECKED);
		break;
	}
}

edge *GetDialogObject(PDLGX dd) {
	int i;

	for(i=1;i<=dd[0].item;i++)
	if(dd[i].type==DXT_OBJ)
	return dd[i].data.mdata.e;

	return (edge*)NULL;
}


void ReturnDialogData(HWND hwnd,PDLGX dd) {
	int i,j;
	char buff[32];

	for(i=1;i<=dd[0].item;i++)
	switch(dd[i].type) {
		case DXT_INT:
			dd[i].data.idata=GetDlgItemInt(hwnd,dd[i].item,NULL,TRUE);
		break;
		case DXT_TXT:
			free(dd[i].data.tdata);	// destroy old string
			j=GetDlgItemText(hwnd , dd[i].item , buff , 32); // get new string length
			dd[i].data.tdata=(char *)malloc(j+1); // allocate room for string
			GetDlgItemText(hwnd , dd[i].item , dd[i].data.tdata , j+1); // get string
		break;
		case DXT_NUM:
			dd[i].data.fdata=GetDlgItemFloat(hwnd,dd[i].item);
		break;
		case DXT_VEC:
			dd[i].data.vdata[X]=GetDlgItemFloat(hwnd,dd[i].item+X);
			dd[i].data.vdata[Y]=GetDlgItemFloat(hwnd,dd[i].item+Y);
			dd[i].data.vdata[Z]=GetDlgItemFloat(hwnd,dd[i].item+Z);
		break;
		case DXT_TTL:
			// titling does not get a return value
		break;
		case DXT_FLG:
			dd[i].data.idata=(IsDlgButtonChecked(hwnd,dd[i].item)==BST_CHECKED)?TRUE:FALSE;
		break;
	}
}

void DestroyDialogData(PDLGX dd) {
	int i;

	for(i=1;i<=dd[0].item;i++)
	switch(dd[i].type) {
		case DXT_INT:
		case DXT_NUM:
		case DXT_TTL:
			// passed data is left intact
		break;
		case DXT_TXT:
			free(dd[i].data.tdata);
		break;
	}
	free(dd);
}

