#include "data.h"

void WriteINCFile(HANDLE fhand,PMODEL m) {
	part* p;
	vert* v;
	face* f;
	edge* e;
	tint *t;
	char *c;
	UINT	i;
	BOOL drop;
	vec redux;

	RemoveUnusedUVPts(m);
	ReindexModelObjects(m);
	CalcModelAngles(m);

	WriteString(fhand,"#include \42transforms.inc\42\15\12#include \42nsss.inc\42\15\12");

	STEPPARTS(m,p) {
		c=p->Name;
// write ifndef block for AngleX
		WriteStrings(fhand,"#ifndef(",c,"_ax) #local ",c,"_ax=",NULL);
		WriteFloatString(fhand,p->AngleX.use);
		WriteStrings(fhand,"; #end\15\12",NULL);
		WriteStrings(fhand,"#ifdef(",c,"_dx) #local ",c,"_ax=",c,"_ax + ",c,
			"_dx; #end\15\12",NULL);

// write ifndef block for AngleY
		if((p->Flags&PT_MASK)!=PT_HINGE) {
			WriteStrings(fhand,"#ifndef(",c,"_ay) #local ",c,"_ay=",NULL);
			WriteFloatString(fhand,p->AngleY.use);
			WriteStrings(fhand,"; #end\15\12",NULL);
			WriteStrings(fhand,"#ifdef(",c,"_dy) #local ",c,"_ay=",c,"_ay + ",c,
				"_dy; #end\15\12",NULL);
		}

// write ifndef block for AngleZ
		WriteStrings(fhand,"#ifndef(",c,"_az) #local ",c,"_az=",NULL);
		WriteFloatString(fhand,p->AngleZ.use);
		WriteStrings(fhand,"; #end\15\12",NULL);
		WriteStrings(fhand,"#ifdef(",c,"_dz) #local ",c,"_az=",c,"_az + ",c,
			"_dz; #end\15\12",NULL);

// write ifndef block for Length
		WriteStrings(fhand,"#ifndef(",c,"_sl) #local ",c,"_sl=",NULL);
		WriteFloatString(fhand,p->Length.use);
		WriteString(fhand,"; #end\15\12");
		WriteStrings(fhand,"#ifdef(",c,"_dl) #local ",c,"_sl=",c,"_sl + ",c,
			"_dl; #end\15\12",NULL);

		if(p->Parent==NULL) {
			WriteStrings(fhand,"#ifndef(",c,"_p) #local ",c,"_p=",NULL);
			WriteVecString(fhand,p->Base->Spot);
			WriteString(fhand,"; #end\15\12");
			WriteStrings(fhand,"#ifdef(",c,"_dp) #local ",c,"_p=",c,"_p + ",c,
				"_dp; #end\15\12",NULL);
		}
		WriteString(fhand,"\15\12");
	}

// write part build for root parts
	STEPPARTS(m,p) {
		p->Flags&=~TF_MARKED;
		if(p->Parent==NULL) {
			WritePartBuild(fhand,p);
			p->Flags|=TF_MARKED;
		}
	}

// write part builds for all other parts
	do {
		drop=TRUE;
		STEPPARTS(m,p)
		if((p->Flags&TF_MARKED)==0)
		if(p->Parent->Flags&TF_MARKED) {
			drop=FALSE;
			WritePartBuild(fhand,p);
			p->Flags|=TF_MARKED;
		}
	} while (drop==FALSE);

	WriteString(fhand,"\15\12");

	i=0;
	STEPVERTS(m,v) {
		i++;
		WriteString(fhand,"#local pV");
		WriteHexString(fhand,v->Index);
		if(v->Owner==NULL) {
			WriteVecString(fhand,v->Spot);
			WriteString(fhand,";\15\12");
		} else {
			c=v->Owner->Name;
			WriteString(fhand,"=vtransform(");
			if(v->Flags&VF_WITHB) {
				InvertVector(v->Owner->mB,v->Spot,redux);
				WriteVecString(fhand,redux);
				WriteStrings(fhand,",",c,"_tb);\15\12",NULL);
			} else {
				InvertVector(v->Owner->mE,v->Spot,redux);
				WriteVecString(fhand,redux);
				WriteStrings(fhand,",",c,"_te);\15\12",NULL);
			}
		}
	}

	if(m->Vertices.pop) {
// 	write the vertices array
		WriteString(fhand,"\15\12#local apV=array[");
		WriteIntString(fhand,m->Vertices.pop);
	 	WriteString(fhand,"] {");

		i=0;
		STEPVERTS(m,v) {
			if(i) WriteString(fhand,",");
			if(i==17 || i==0) { WriteString(fhand,"\15\12"); i=1; }
			WriteString(fhand,"pV");
			WriteHexString(fhand,v->Index);
			i++;
		}
		WriteString(fhand,"\15\12}\15\12");
	}

	if(m->Faces.pop) {
// write the faces array
		WriteString(fhand,"\15\12#local aiF=array[");
		WriteIntString(fhand,m->Faces.pop);
		WriteString(fhand,"][4] {");

		i=0;
		STEPFACES(m,f) {
			if(i) WriteString(fhand,",");
			i=1;
			WriteString(fhand,"\15\12{ ");
			WriteFloatString(fhand,f->VertA->Index);
			WriteString(fhand,",");
			WriteFloatString(fhand,f->VertB->Index);
			WriteString(fhand,",");
			WriteFloatString(fhand,f->VertC->Index);
			WriteString(fhand,",");
			if(f->VertD==NULL) {
				WriteString(fhand,"-1 }");
			} else {
				WriteFloatString(fhand,f->VertD->Index);
				WriteString(fhand," }");
			}
		}
		WriteString(fhand,"\15\12}\15\12\15\12SSS_ImportBasicMesh(apV,aiF)\15\12");
	}

	i=0;
	STEPEDGES(m,e)
	if(e->Flags&TF_SHARP)
	i++;

	if(i) {
		drop=FALSE;
		WriteString(fhand,"\15\12#local aiS=array[");
		WriteIntString(fhand,i);
		WriteString(fhand,"][3] {");
		STEPEDGES(m,e)
		if(e->Flags&TF_SHARP) {
			if(drop) WriteString(fhand,",");
			drop=TRUE;
			WriteString(fhand,"\15\12{ ");
			WriteIntString(fhand,e->VertS->Index);
			WriteString(fhand,",");
			WriteIntString(fhand,e->VertE->Index);
			WriteString(fhand,",-1 }");
		}
		WriteString(fhand,"\15\12}\15\12\15\12SSS_AddSharpData(aiS)\15\12\15\12");
	}

// write uv-mapping data
	i=0;
	STEPFACES(m,f)
	if(f->MapA)
	i++;

	if(i) { // yes, there's uv-mapping
		i=0;
		WriteString(fhand,"\15\12#local aiM=array[");
		WriteIntString(fhand,m->Faces.pop);
		WriteString(fhand,"][4] {\15\12");

		STEPFACES(m,f) {
			if(i) WriteString(fhand,",\15\12");
			i=1;
			if(f->MapA) {
				WriteString(fhand,"{ ");
				WriteUVecString(fhand,f->MapA->Spot);
				WriteString(fhand,",");
				WriteUVecString(fhand,f->MapB->Spot);
				WriteString(fhand,",");
				WriteUVecString(fhand,f->MapC->Spot);
				if(f->VertD) {
					WriteUVecString(fhand,f->MapD->Spot);
				} else {
					WriteString(fhand,"<1,0>");
				}
				WriteString(fhand," }");
			} else {
				WriteString(fhand,"{ <0,0>,<0,1>,<1,1>,<1,0> }");
			}
		}
		WriteString(fhand,"\15\12}\15\12\15\12SSS_AddUVMapping(aiM)\15\12");
	}

// now write texturing data
	i=0;
	STEPFACES(m,f)
	if(f->Texture!=m->defTint)
	i++;

	if(i) { // yes, there was a face with texturing data
		i=0;
		WriteString(fhand,"\15\12#local aiT=array[");
		WriteIntString(fhand,m->Faces.pop);
		WriteString(fhand,"] {");
		STEPFACES(m,f) {
			if(i) WriteString(fhand,",");
			if(i==17 || i==0) { WriteString(fhand,"\15\12"); i=1; }
			i++;
			if(f->Texture!=m->defTint) {
				WriteIntString(fhand,f->Texture->Index);
			} else {
				WriteString(fhand,"-1");
			}
		}
		WriteString(fhand,"\15\12}\15\12\15\12SSS_AddTextures(aiT)\15\12\15\12");

		STEPTINTS(m,t)
		if(t!=m->defTint) {
			WriteString(fhand,"// texture ");
			WriteIntString(fhand,t->Index);
			WriteStrings(fhand," is named ",t->Name," in the model.\15\12",NULL);
		}
	}
}

void WritePartBuild(HANDLE fhand,part* p) {
	char *n,*pn;
	matrix m;

	getInheritedMatrix(p,m);
	Cart2Polar(p,m);

	n=p->Name;

	pn=NULL;
	if(p->Parent) pn=p->Parent->Name;

	switch(p->Flags&PT_MASK) {
	case PT_UNI:
		WriteStrings(fhand,"#declare ",n,"_tb=transform { rotate <",n,"_ax,",n,NULL);
		if(pn) { // has a parent
			WriteStrings(fhand,"_ay,0> transform ",pn,"_te }\15\12",NULL);
		} else {
			WriteStrings(fhand,"_ay,0> translate ",n,"_p }\15\12",NULL);
		}
	break;
	case PT_HINGE:
		WriteStrings(fhand,"#declare ",n,"_tb=transform { rotate x*",n,"_ax ",NULL);
		if(pn) { // has a parent
			WriteStrings(fhand,"transform ",pn,"_te }\15\12",NULL);
		} else {
			WriteStrings(fhand,"translate ",n,"_p }\15\12",NULL);
		}
	break;
	case PT_BALL:
		WriteStrings(fhand,"#declare ",n,"_tb=transform { rotate -z*",n,
			"_ay rotate <",n,"_ax,0,",n,NULL);
		if(pn) { // has a parent
			WriteStrings(fhand,"_ay> transform ",pn,"_te }\15\12",NULL);
		} else {
			WriteStrings(fhand,"_ay> translate ",n,"_p }\15\12",NULL);
		}
	break;

	}
	WriteStrings(fhand,"#declare ",n,"_te=transform { rotate z*",n,
		"_az translate z*",n,"_sl transform ",n,"_tb }\15\12",NULL);
}

