#include "lists.h"

void initChain(chain* c) {
	c->pop=0;

	c->Next=&c->Stub;
	c->Stub.Prev=(link*)c;
	c->Stub.Next=c->Prev=(link*)0;
}

void addHead(chain* c,link* l) {
// link l to old head
	l->Next=c->Next;
// link l to dummy head
	l->Prev=(link*)c;

// link old head to l
	c->Next->Prev=l;
// link dummy head to l
	c->Next=l;
// increment population
	c->pop++;
}

void addTail(chain* c,link* l) {

// link l to old tail
	l->Prev=c->Stub.Prev;
// link l to dummy tail
	l->Next=&c->Stub;
// link old tail to l
	c->Stub.Prev->Next=l;
// link dummy tail to l
	c->Stub.Prev=l;
// increment population
	c->pop++;
}

link *remHead(chain* c) {
	link *l;

	if(c->pop==0) return (link*)0;

// get current head
	l=c->Next;

// point dummy head to second link
	c->Next=l->Next;
// point new head to dummy head
	c->Next->Prev=(link*)c;

//	l->Next=l->Prev=(link*)NULL;

	c->pop--;

	return l;
}

link *remTail(chain* c) {
	link* l;
	if(c->pop==0) return (link*)0;

	l=c->Stub.Prev;

// point dummy tail to penultimate link
	c->Stub.Prev=l->Prev;
// point new tail to dummy tail
	c->Stub.Prev->Next=&c->Stub;

//	l->Next=l->Prev=(link*)NULL;

	c->pop--;

	return l;
}

void remLink(link* l) {
	chain *c;

// links are only removed if they're actually linked in
	if(l->Next==(link*)0) return;
	if(l->Prev==(link*)0) return;

// find the head; &head = &chain
	c=findChain(l);
	c->pop--;

// point following link to preceding link
	l->Next->Prev=l->Prev;
// point preceding link to following link
	l->Prev->Next=l->Next;
//	l->Next=l->Prev=(link*)0;
}

chain *findChain(link *l) {
	if(l==(link*)0) return (chain *)0;
	while(l->Prev) l=l->Prev;
	return (chain *)l;
}

thing *index(chain*c,INDEX i) {
	thing *t;

	for(t=(thing*)(c->Next);t!=(thing*)(&c->Stub);t=(thing*)t->Next)
	if(t->Index==i) return t;
	return (thing*)0;
}



