#ifndef LISTS_H
#define LISTS_H

#include "lsmtypes.h"

typedef struct LINK {
		struct LINK *Next,*Prev;
} link;

#define NEXT(l) (((link*)l)->Next)

typedef struct {
	link *Next,*Prev;
	FLAGS	Flags;	// for flagging
	INDEX	Index;	// for indexing
} thing;

#define THINGMEMBERS link *Next,*Prev; FLAGS Flags; INDEX Index;

typedef struct {
	link *Next,*Prev;
	link	Stub;
	int	pop;
} chain;

void initChain(chain*);
void addHead(chain*,link*);
void addTail(chain*,link*);
link *remHead(chain*);
link *remTail(chain*);
thing *index(chain*,INDEX);

chain *findChain(link *);
void remLink(link*);

#define TF_MARKED	1	// marked by the user for some reason
#define TF_DRAGGED	2	// needs to be redrawn with mouse move
#define	TF_NEW		4	// created in current operation
#define TF_SHARP	8	// edges and vertices are sharp sometimes

#endif
