#include <windows.h>
#include "data.h"
#include "lsmres.h"

extern HMENU ModelMenu;
extern MYPTR HighItem;
extern PPROJECT ActiveProject;

MENUITEMINFO mii= {
	sizeof(MENUITEMINFO),
	MIIM_ID|MIIM_FTYPE|MIIM_STATE|MIIM_STRING,
	MFT_STRING,MFS_ENABLED,IDM_DEFTINT,
	NULL,
	NULL,
	NULL,
	0,
	NULL,
	0 //,
//	NULL
};
MENUITEMINFO emii= {
	sizeof(MENUITEMINFO),
	MIIM_ID|MIIM_FTYPE|MIIM_STATE|MIIM_STRING,
	MFT_STRING,MFS_ENABLED,IDM_EDITMAPPING,
	NULL,
	NULL,
	NULL,
	0,
	"Edit uv-mapping...",
	0 //,
//	NULL
};
MENUITEMINFO cmii= {
	sizeof(MENUITEMINFO),
	MIIM_ID|MIIM_FTYPE|MIIM_STATE|MIIM_STRING,
	MFT_STRING,MFS_ENABLED,IDCANCEL,
	NULL,
	NULL,
	NULL,
	0,
	"Cancel",
	0 //,
//	NULL
};
MENUITEMINFO tmii= {
	sizeof(MENUITEMINFO),
	MIIM_ID|MIIM_FTYPE|MIIM_STATE|MIIM_STRING,
	MFT_STRING,MFS_ENABLED,IDM_ADDTEXTURE,
	NULL,
	NULL,
	NULL,
	0,
	"Select texture...",
	0//,
//	NULL
};
MENUITEMINFO smii= {
	sizeof(MENUITEMINFO),
	MIIM_FTYPE,
	MFT_SEPARATOR,MFS_DISABLED,IDCANCEL,
	NULL,
	NULL,
	NULL,
	0,
	NULL,
	0//,
//	NULL
};
MENUITEMINFO amii= {
	sizeof(MENUITEMINFO),
	MIIM_ID|MIIM_FTYPE|MIIM_STATE|MIIM_STRING,
	MFT_STRING,MFS_ENABLED,IDM_ADDMAPPING,
	NULL,
	NULL,
	NULL,
	0,
	"Add uv-mapping",
	0//,
//	NULL
};
MENUITEMINFO rmii= {
	sizeof(MENUITEMINFO),
	MIIM_ID|MIIM_FTYPE|MIIM_STATE|MIIM_STRING,
	MFT_STRING,MFS_ENABLED,IDM_REMMAPPING,
	NULL,
	NULL,
	NULL,
	0,
	"Remove uv-mapping",
	0//,
//	NULL
};
MENUITEMINFO dmii= {
	sizeof(MENUITEMINFO),
	MIIM_ID|MIIM_FTYPE|MIIM_STATE|MIIM_STRING,
	MFT_STRING,MFS_ENABLED,IDM_DELHIGH,
	NULL,
	NULL,
	NULL,
	0,
	"Delete",
	0//,
//	NULL
};

HMENU BuildTintPopup(PMODEL m) {
	char *s;
	HMENU tpmenu;

	tpmenu=CreatePopupMenu();

	InsertMenuItem(tpmenu,0,TRUE,&cmii);
	InsertMenuItem(tpmenu,0,TRUE,&smii);
	InsertMenuItem(tpmenu,0,TRUE,&dmii);
	if(HighItem.f)
	if(HighItem.f->MapA==NULL) {
		InsertMenuItem(tpmenu,0,TRUE,&amii);
	} else {
		InsertMenuItem(tpmenu,0,TRUE,&emii);
		InsertMenuItem(tpmenu,0,TRUE,&rmii);
	}
	InsertMenuItem(tpmenu,0,TRUE,&tmii);
	if(m->CurTint!=m->defTint) {
		s=ConcatStrings("Apply texture ",m->CurTint->Name);
		mii.dwTypeData=s;
		InsertMenuItem(tpmenu,0,TRUE,&mii);
		DestroyString(s);
	}

	return tpmenu;
}

void UpdateModelMenu(void) {
	MENUITEMINFO qmii;

	if(ActiveProject==NULL) return;

	memset(&qmii,0,sizeof(MENUITEMINFO));

	qmii.cbSize=sizeof(MENUITEMINFO);
	qmii.fMask=MIIM_STRING;

	if(ActiveProject->Flags&MF_SHOWPARTS) {
		qmii.dwTypeData="Hide &parts";
	} else {
		qmii.dwTypeData="Show &parts";
	}
	SetMenuItemInfo(ModelMenu,IDM_SHOWPARTS,FALSE,&qmii);

	if(ActiveProject->Flags&MF_SHOWVERTS) {
		qmii.dwTypeData="Hide &vertices";
	} else {
		qmii.dwTypeData="Show &vertices";
	}
	SetMenuItemInfo(ModelMenu,IDM_SHOWVERTS,FALSE,&qmii);

	if(ActiveProject->Flags&MF_SHOWEDGES) {
		qmii.dwTypeData="Hide &edges";
	} else {
		qmii.dwTypeData="Show &edges";
	}
	SetMenuItemInfo(ModelMenu,IDM_SHOWEDGES,FALSE,&qmii);

	if(ActiveProject->Flags&MF_SHOWFACES) {
		qmii.dwTypeData="Hide &faces";
	} else {
		qmii.dwTypeData="Show &faces";
	}
	SetMenuItemInfo(ModelMenu,IDM_SHOWFACES,FALSE,&qmii);

	if(ActiveProject->Flags&PF_SHOWAXES) {
		qmii.dwTypeData="Hide &Axes\tCtrl+A";
	} else {
		qmii.dwTypeData="Show &Axes\tCtrl+A";
	}
	SetMenuItemInfo(ModelMenu,IDM_TOGGLEAXES,FALSE,&qmii);

}

