#ifndef MESH_H
#define MESH_H

#include "lists.h"
#include "skel.h"

typedef struct Vert {
	THINGMEMBERS
	vec	Spot,Save;
	part *Owner;
	long	Select;
	struct Vert *Copy;
	short	Factor;
} vert;

#define VF_WITHB	16
#define	VF_LOCKED	32

typedef struct {
	THINGMEMBERS
	vert	*VertS,*VertE;
	struct Face	*FaceL,*FaceR;
} edge;

#define EF_NOLEFT	16
#define EF_NORIGHT	32
#define EF_PENMASK	56
#define EF_SHARPMASK	56

typedef struct Face {
	THINGMEMBERS
	vert	*VertA,*VertB,*VertC,*VertD;
	edge	*EdgeE,*EdgeF,*EdgeG,*EdgeH;
	uvpt	*MapA,*MapB,*MapC,*MapD;
	tint*	Texture;
} face;

#endif

