#include <windows.h>
#include "gl/gl.h"
#include "gl/glu.h"
#include "data.h"
#include <math.h>

#define SELBUFFSIZE 512

extern PPROJECT ActiveProject;
extern HWND hwndMain;

short cX,cY,lX,lY,oX,oY,rX,rY;
short MouseMode=MM_NOTHING;
MYPTR HighItem,drag,anch;
short HighType=HT_NOTHING;

RECT windRect,statRect;

vec scr,xyz,tmp;

matrix iem,ibm,em,bm,qm;

BOOL Popup=FALSE;

void LeftClick(HWND hwnd,WPARAM wParam,LPARAM lParam) {
//	PVERT v;
//	HDC tdc;
	int i;

	if(ActiveProject==NULL) return;

//	if(ActiveProject->EditMode==EM_TINTEDIT) return;

	cX=lX=LOWORD(lParam);
	cY=lY=HIWORD(lParam);
	switch(ActiveProject->EditMode|MouseMode) {

	case EM_MESHEDIT|MM_PANVIEW0:
	case EM_MAPEDIT|MM_PANVIEW0:
		if(ActiveProject) {
			SetMouseMode(MM_PANVIEW1);
			ActiveProject->sView.Orient[LX]=ActiveProject->cView.Orient[LX];
			ActiveProject->sView.Orient[LY]=ActiveProject->cView.Orient[LY];
			ActiveProject->sView.Orient[LZ]=ActiveProject->cView.Orient[LZ];
			SetCapture(hwndMain);
		}
	break;

	case EM_MESHEDIT|MM_ZOOMVIEW0:
	case EM_MAPEDIT|MM_ZOOMVIEW0:
		if(ActiveProject) {
			SetMouseMode(MM_ZOOMVIEW1);
			ActiveProject->sView.Scale=ActiveProject->cView.Scale;
			SetCapture(hwndMain);
		}
	break;

	case EM_MESHEDIT|MM_ROTVIEW0:
	case EM_MAPEDIT|MM_ROTVIEW0:
		if(ActiveProject) {
			SetMouseMode(MM_ROTVIEW1);
			for(i=0;i<12;i++)
			ActiveProject->sView.Orient[i]=ActiveProject->cView.Orient[i];
			SetCapture(hwndMain);
		}
	break;

	case EM_MESHEDIT|MM_HOOKVERT:
		if(HighType==HT_PART) {
			AttachMarked(HighItem.p);
			SetMouseMode(MM_NOTHING);
		}
	break;
	case EM_MESHEDIT|MM_HOOKHIGH:
		if(HighType==HT_PART) {
			AttachVertex(drag.v,HighItem.p);
			SetMouseMode(MM_NOTHING);
		}
	break;

	case EM_MESHEDIT|MM_ADDMESH0:
		if(HighType==HT_VERT) {
			anch.v=HighItem.v;
		} else {
			anch.v=CreateVertex(NULL,cX,cY,FALSE);
			anch.v->Flags|=TF_NEW;
		}
		InvalidateView();
		anch.v->Select=1;
		SetMouseMode(MM_ADDMESH1);
	break;

	case EM_MESHEDIT|MM_ADDVERT:
		CreateVertex(NULL,cX,cY,TRUE);
		InvalidateView();
	break;

	case EM_MESHEDIT|MM_ADDMESH1:
		SetMouseMode(MM_ADDMESH0);
	break;

	case EM_MESHEDIT|MM_ADDMESH2:
		if(HighType==HT_VERT) {
			edge* e;
			e=FindEdge(NULL,anch.v,HighItem.v);
			if(e==NULL) {
   				e=CreateEdge(NULL,anch.v,HighItem.v,FALSE);
				e->Flags|=TF_NEW;
			}
			DestroyVertex(drag.v,FALSE);
			drag.v=HighItem.v;
			switch(HighItem.v->Select) {
				case 0:
				break;
				case 3:
					DecSelection();
				case 2:
					DecSelection();
				break;
				case 4:
					CreateFace(NULL,SelectVert(NULL,2),SelectVert(NULL,3),SelectVert(NULL,4),
						NULL,FALSE)->Flags|=TF_NEW;
					BlankSelection();
					InvalidateView();
				break;
				case 5:
					CreateFace(NULL,SelectVert(NULL,2),SelectVert(NULL,3),SelectVert(NULL,4),
						SelectVert(NULL,5),FALSE)->Flags|=TF_NEW;
					BlankSelection();
					InvalidateView();
				break;
				default:
					BlankSelection();
					InvalidateView();
				break;
			}
		}
		anch.v=drag.v;
		drag.v=NULL;
		anch.v->Select=1;
		SetMouseMode(MM_ADDMESH1);
		ReleaseCapture();
	break;

	case EM_MESHEDIT|MM_ADDPART0:
		if(HighType==HT_KNOB) {
			anch.k=HighItem.k;
		} else {
			anch.k=CreateKnob(NULL,cX,cY,TRUE);
			InvalidateView();
		}
		SetMouseMode(MM_ADDPART1);
	break;
	case EM_MESHEDIT|MM_ADDPART1:
		SetMouseMode(MM_ADDPART0);
	break;
	case EM_MESHEDIT|MM_ADDPART2:
		anch.k=drag.k;
		SetMouseMode(MM_ADDPART1);
		ReleaseCapture();
	break;
	case EM_MESHEDIT|MM_NOTHING:
		switch(wParam) {
		case MK_LBUTTON:
			ClearAll();
		case MK_LBUTTON|MK_SHIFT:
			CheckHighlight(HT_VERT|HT_KNOB|HT_PART|HT_EDGE|HT_CLEAR);
			switch(HighType) {
				case HT_VERT:
					SetMouseMode(MM_GRABVERT);
				break;
				case HT_KNOB:
					drag.k=HighItem.k;
					InvalidateView();
					PrepSingleKnobDrag(drag.k);
					SetMouseMode(MM_DRAGKNOB);
					SetCapture(hwndMain);
				break;
				default:
					if(ActiveProject) {
						SetMouseMode(MM_LEFTDOWN);
						SetCapture(hwndMain);
					}
				break;
			}
		break;
		case MK_CONTROL|MK_LBUTTON:
		if(ActiveProject) {
//			ClipDeltaChain(ActiveProject);
			PrepVertDrag();
			SetCapture(hwnd);
			SetMouseMode(MM_DRAGVERT);
		}
		break;
		}
	break;

	case EM_MAPEDIT|MM_NOTHING:
		CheckHighlight(HT_UVPT|HT_CLEAR);
		switch(HighType) {
			case HT_UVPT:
				SetMouseMode(MM_GRABVERT);
			break;
		}
	break;

	}
}

void LeftDoubleClick(HWND hwnd,WPARAM wParam,LPARAM lParam) {
//	PVERT v;

	if(ActiveProject==NULL) return;

//	if(ActiveProject->EditMode==EM_TINTEDIT) return;
	if(ActiveProject->EditMode==EM_MAPEDIT) return;

	cX=lX=LOWORD(lParam);
	cY=lY=HIWORD(lParam);
	switch(ActiveProject->EditMode|MouseMode) {
	case EM_MESHEDIT|MM_NOTHING:
		switch(wParam) {
		case MK_LBUTTON:
			CheckHighlight(HT_VERT|HT_KNOB|HT_PART|HT_EDGE|HT_CLEAR);
			SetMouseMode(MM_DBLCLICK);
		break;
		}
	break;
	}
}

void RightClick(HWND hwnd,WPARAM wParam,LPARAM lParam) {
	MYPTR m;
//	register short i;

	if(ActiveProject==NULL) return;

	Popup=FALSE;

	switch(MouseMode) {
	case MM_LEFTDOWN:
		return;
	}

	cX=lX=LOWORD(lParam);
	cY=lY=HIWORD(lParam);

	switch(ActiveProject->EditMode|MouseMode) {
		case EM_MESHEDIT|MM_PANVIEW0:
		case EM_MAPEDIT|MM_PANVIEW0:
		case EM_MESHEDIT|MM_ZOOMVIEW0:
		case EM_MAPEDIT|MM_ZOOMVIEW0:
		case EM_MESHEDIT|MM_ROTVIEW0:
		case EM_MESHEDIT|MM_ADDVERT:
		case EM_MESHEDIT|MM_ADDMESH0:
		case EM_MESHEDIT|MM_ADDPART0:
			SetMouseMode(MM_NOTHING);
		break;

		case EM_MESHEDIT|MM_DBLCLICK:
			SetMouseMode(MM_DBLCLICX);
		break;
		case EM_MESHEDIT|MM_GRABVERT:
			SetMouseMode(MM_GRABVERX);
		break;
		case EM_MESHEDIT|MM_HOOKVERT:
		case EM_MESHEDIT|MM_HOOKHIGH:
			SetMouseMode(MM_HOOKVERX);
		break;
		case EM_MESHEDIT|MM_ADDPART1:
			SetMouseMode(MM_ADDPARTX);
		break;
		case EM_MESHEDIT|MM_ADDPART2:
			InvalidateView();
			DestroyPart(drag.k->Owner,FALSE);
			DestroyKnob(drag.k,FALSE);
			drag.k=NULL;
			if(anch.k->Owner==NULL) {
//				InvalidateView();
				DestroyKnob(anch.k,FALSE);
			}
			anch.k=NULL;
			ReleaseCapture();
			SetMouseMode(MM_ADDPARTX);
		break;

		case EM_MESHEDIT|MM_ADDMESH1:
		case EM_MESHEDIT|MM_ADDMESH2:
			DestroyVertex(drag.v,FALSE);
			STEPVERTS(ActiveProject,m.v)
			if(m.v->Flags&TF_NEW) {
				CreateVertDelta(m.v,DT_ADD);
				m.v->Flags&=~TF_NEW;
			}
			STEPEDGES(ActiveProject,m.e)
			if(m.e->Flags&TF_NEW) {
				CreateEdgeDelta(m.e,DT_ADD);
				m.e->Flags&=~TF_NEW;
			}
			STEPFACES(ActiveProject,m.f)
			if(m.f->Flags&TF_NEW) {
				CreateFaceDelta(m.f,DT_ADD);
				m.f->Flags&=~TF_NEW;
			}
			AddAtomDelta(ActiveProject);
			InvalidateView();
			ReleaseCapture();
			SetMouseMode(MM_ADDMESHX);
		break;

		case EM_MESHEDIT|MM_NOTHING:
		case EM_MAPEDIT|MM_NOTHING:
			SetMouseMode(MM_RIGHTDOWN);
		break;
		case EM_MESHEDIT|MM_DRAGVERT:
			STEPVERTS(ActiveProject,m.v)
			if(m.v->Flags&TF_DRAGGED)
			CreateVertDelta(m.v,DT_CHG);
			AddAtomDelta(ActiveProject);
			SetMouseMode(MM_NOTHING);
			ReleaseCapture();
		break;
		case EM_MESHEDIT|MM_DRAGKNOB:
			RebuildPartMatrices();
			SetMouseMode(MM_DRAGKNOBX);
			ReleaseCapture();
		break;
		case EM_MAPEDIT|MM_DRAGVERT:
		case EM_MAPEDIT|MM_GRABVERT:
			SetMouseMode(MM_NOTHING);
			drag.u=NULL;
			ReleaseCapture();
		break;
	}
}

void MouseMove(HWND hwnd,WPARAM wParam,LPARAM lParam) {
//	PKNOB k;
	HDC tdc;
	vert* v;
	edge* e;
	float aX,aY,aR;
	float fC,fS;
	matrix rot;

	if(ActiveProject==NULL) return;

	oX=lX;
	oY=lY;

	lX=LOWORD(lParam);
	lY=HIWORD(lParam);

	switch(ActiveProject->EditMode|MouseMode) {
	case EM_MAPEDIT|MM_GRABVERT:
		drag.u=HighItem.u;
		InvalidateView();
		drag.u->Save[U]=drag.u->Spot[U];
		drag.u->Save[V]=drag.u->Spot[V];
		SetMouseMode(MM_DRAGVERT);
		SetCapture(hwndMain);
	break;
	case EM_MESHEDIT|MM_GRABVERT:
		drag.v=HighItem.v;
		InvalidateView();
//		ClipDeltaChain(ActiveProject);
		PrepSingleVertDrag(drag.v);
		SetMouseMode(MM_DRAGVERT);
		SetCapture(hwndMain);
	break;
	case EM_MAPEDIT|MM_LEFTDOWN:
	case EM_MESHEDIT|MM_LEFTDOWN:
		tdc=GetDC(hwndMain);
		windRect.top=cY;
		windRect.left=cX;
		windRect.right=lX;
		windRect.bottom=lY;
		RightRect(&windRect);
		DrawFocusRect(tdc,&windRect);
		ReleaseDC(hwndMain,tdc);
		SetMouseMode(MM_LEFTBOX);
	break;
	case EM_MAPEDIT|MM_LEFTBOX:
	case EM_MESHEDIT|MM_LEFTBOX:
		tdc=GetDC(hwndMain);
		windRect.top=cY;
		windRect.left=cX;
		windRect.right=oX;
		windRect.bottom=oY;
		RightRect(&windRect);
		DrawFocusRect(tdc,&windRect);
		windRect.top=cY;
		windRect.left=cX;
		windRect.right=lX;
		windRect.bottom=lY;
		RightRect(&windRect);
		DrawFocusRect(tdc,&windRect);
		ReleaseDC(hwndMain,tdc);
	break;
	case EM_MESHEDIT|MM_NOTHING:
		CheckHighlight(HT_VERT|HT_KNOB|HT_EDGE|HT_PART|HT_FACE);
	break;
	case EM_MAPEDIT|MM_NOTHING:
		CheckHighlight(HT_UVPT);
	break;
	case EM_MAPEDIT|MM_ZOOMVIEW1:
	case EM_MESHEDIT|MM_ZOOMVIEW1:
		aR=(float)(cY-lY)/(float)ActiveProject->cView.sM*2.0*LN10;
		fS=ActiveProject->sView.Scale*(float)exp((double)aR);
		if(fS<.0015) fS=.0015;
		if(fS>100000.0) fS=100000.0;
		ActiveProject->cView.Scale=fS;
		InvalidateView();
	break;
	case EM_MESHEDIT|MM_PANVIEW1:
	case EM_MAPEDIT|MM_PANVIEW1:
		mapScr2XYZ(&ActiveProject->cView,cX,cY,xyz);
		mapScr2XYZ(&ActiveProject->cView,lX,lY,scr);

		ActiveProject->cView.Orient[LX]=ActiveProject->sView.Orient[LX]+xyz[X]-scr[X];
		ActiveProject->cView.Orient[LY]=ActiveProject->sView.Orient[LY]+xyz[Y]-scr[Y];
		ActiveProject->cView.Orient[LZ]=ActiveProject->sView.Orient[LZ]+xyz[Z]-scr[Z];
		InvalidateView();
	break;
	case EM_MESHEDIT|MM_ROTVIEW1:
		aX=(float)(lX-cX);
		aY=(float)(cY-lY);
		aR=(float)sqrt((double)(aX*aX+aY*aY));
		if(aR!=0.0) {
			aX/=aR;
			aY/=aR;
		}
		aR*=(PI/(float)ActiveProject->cView.sM);
		fC=(float)cos((double)aR);
		fS=(float)sin((double)aR);

		rot[XX]=aY*aY*(1.0-fC)+fC;
		rot[XY]=-aX*aY*(1.0-fC);
		rot[XZ]=-aX*fS;

		rot[YX]=rot[XY];
		rot[YY]=aX*aX*(1.0-fC)+fC;
		rot[YZ]=-aY*fS;

		rot[ZX]=-rot[XZ];
		rot[ZY]=-rot[YZ];
		rot[ZZ]=fC;
		rot[LX]=rot[LY]=rot[LZ]=0.0;
		MatrixMultiply(rot,ActiveProject->sView.Orient,ActiveProject->cView.Orient);
		ActiveProject->cView.Flags|=VF_NONPARALLEL;
		InvalidateView();
	break;

// looking for a part, but previously highlighted one stays highlighted
	case EM_MESHEDIT|MM_HOOKVERT:
	case EM_MESHEDIT|MM_HOOKHIGH:
		CheckHighlight(HT_PART);
	break;
// looking for a part, not dragging anything
	case EM_MESHEDIT|MM_ADDPART0:
		CheckHighlight(HT_KNOB|HT_CLEAR|HT_NORISE);
	break;

// looking for vertices only, no active drag operation
	case EM_MESHEDIT|MM_ADDMESH0:
		CheckHighlight(HT_VERT|HT_CLEAR);
	break;

// dragging one vertex, on the lookout for another
	case EM_MESHEDIT|MM_ADDMESH2:
		CheckHighlight(HT_VERT|HT_CLEAR);
// dragging a vertex, not looking for another
	case EM_MESHEDIT|MM_DRAGVERT:
		mapScr2XYZ(&ActiveProject->cView,cX,cY,scr);
		mapScr2XYZ(&ActiveProject->cView,lX,lY,xyz);
		xyz[X]-=scr[X];
		xyz[Y]-=scr[Y];
		xyz[Z]-=scr[Z];

		STEPVERTS(ActiveProject,v)
		if(v->Flags&TF_DRAGGED)
		if((v->Flags&VF_LOCKED)==0) {
			v->Spot[X]=v->Save[X]+xyz[X];
			v->Spot[Y]=v->Save[Y]+xyz[Y];
			v->Spot[Z]=v->Save[Z]+xyz[Z];
			if(((PMODEL)ActiveProject)->MeshSnap!=0.0) SnapVertex(v);
		}
		InvalidateView();
	break;
// dragging a uv point, not looking for another
	case EM_MAPEDIT|MM_DRAGVERT:
		mapScr2UV(&ActiveProject->cView,cX,cY,scr);
		mapScr2UV(&ActiveProject->cView,lX,lY,xyz);
		xyz[X]-=scr[X];
		xyz[Y]-=scr[Y];

		drag.u->Spot[U]=drag.u->Save[U]+xyz[X];
		drag.u->Spot[V]=drag.u->Save[V]+xyz[Y];
		if(((PMODEL)ActiveProject)->MapSnap!=0.0)
		snapUVPt(drag.u,((PMODEL)ActiveProject)->MapSnap);

		InvalidateView();
	break;
// dragging a knob, not looking for anything
	case EM_MESHEDIT|MM_DRAGKNOB:
		CheckHighlight(HT_CLEAR|HT_KNOB|HT_NORISE);
	case EM_MESHEDIT|MM_DRAGRISE:
	case EM_MESHEDIT|MM_ADDPART2:
		mapScr2XYZ(&ActiveProject->cView,cX,cY,scr);
		mapScr2XYZ(&ActiveProject->cView,lX,lY,xyz);
		xyz[X]-=scr[X];
		xyz[Y]-=scr[Y];
		xyz[Z]-=scr[Z];

		drag.k->Spot[X]=drag.k->Save[X]+xyz[X];
		drag.k->Spot[Y]=drag.k->Save[Y]+xyz[Y];
		drag.k->Spot[Z]=drag.k->Save[Z]+xyz[Z];
		Constrain(drag.k);
		MoveKnobEnd(drag.k);
		InvalidateView();
	break;

	case EM_MESHEDIT|MM_ADDPART1:
		drag.k=CreateKnob(NULL,lX,lY,TRUE);
		CreatePart(NULL,anch.k,drag.k,NULL,TRUE);
		InvalidateView();
		PrepSingleKnobDrag(drag.k);
		SetMouseMode(MM_ADDPART2);
		SetCapture(hwnd);
	break;

	case EM_MESHEDIT|MM_ADDMESH1:
		IncSelection();
		drag.v=CreateVertex(NULL,lX,lY,FALSE);
		drag.v->Flags|=TF_NEW;
		drag.v->Select=1;
		e=CreateEdge(NULL,anch.v,drag.v,FALSE);
		e->Flags|=TF_NEW;
		InvalidateView();
		PrepSingleVertDrag(drag.v);
		SetMouseMode(MM_ADDMESH2);
		SetCapture(hwnd);
	break;
	}
}

void LeftRelease(HWND hwnd,WPARAM wParam,LPARAM lParam) {
	vert* v;

	if(ActiveProject==NULL) return;

	rX=lX=LOWORD(lParam);
	rY=lY=HIWORD(lParam);
	switch(ActiveProject->EditMode|MouseMode) {
		case EM_MESHEDIT|MM_ROTVIEW1:
		case EM_MAPEDIT|MM_ROTVIEW1:
			ReleaseCapture();
			SetMouseMode(MM_ROTVIEW0);
		break;

		case EM_MAPEDIT|MM_ZOOMVIEW1:
		case EM_MESHEDIT|MM_ZOOMVIEW1:
			ReleaseCapture();
			SetMouseMode(MM_ZOOMVIEW0);
		break;

		case EM_MAPEDIT|MM_PANVIEW1:
		case EM_MESHEDIT|MM_PANVIEW1:
			ReleaseCapture();
			SetMouseMode(MM_PANVIEW0);
		break;

		case EM_MESHEDIT|MM_DBLCLICK:
			EditHighlight(hwnd);
			SetMouseMode(MM_NOTHING);
		break;
		case EM_MESHEDIT|MM_GRABVERT:
			HighItem.v->Flags^=TF_MARKED;
			InvalidateView();
			SetMouseMode(MM_NOTHING);
		break;
		case EM_MESHEDIT|MM_LEFTDOWN:
			SetMouseMode(MM_NOTHING);
			ReleaseCapture();
		break;
		case EM_MESHEDIT|MM_LEFTBOX:
			windRect.top=cY;
			windRect.left=cX;
			windRect.right=lX;
			windRect.bottom=lY;
			RightRect(&windRect);
			SetMouseMode(MM_NOTHING);
			ReleaseCapture();
			if(cX!=lX && cY!=lY)
			CheckSelectBox(&windRect,HT_VERT);
			InvalidateView();
		break;
		case EM_MAPEDIT|MM_LEFTBOX:
			windRect.top=cY;
			windRect.left=cX;
			windRect.right=lX;
			windRect.bottom=lY;
			RightRect(&windRect);
			SetMouseMode(MM_NOTHING);
			ReleaseCapture();
			if(cX!=lX && cY!=lY)
			CheckSelectBox(&windRect,HT_UVPT);
			InvalidateView();
		break;
		case EM_MAPEDIT|MM_DRAGVERT:
		case EM_MAPEDIT|MM_GRABVERT:
			drag.u=NULL;
			SetMouseMode(MM_NOTHING);
			ReleaseCapture();
		break;
		case EM_MESHEDIT|MM_DRAGVERT:
			STEPVERTS(ActiveProject,v)
			if(v->Flags&TF_DRAGGED)
			CreateVertDelta(v,DT_CHG);
			AddAtomDelta(ActiveProject);
			drag.v=NULL;
			SetMouseMode(MM_NOTHING);
			ReleaseCapture();
		break;
		case EM_MESHEDIT|MM_DRAGKNOB:
			if(drag.k)
			if(drag.k->Owner==NULL) // only root can be attached
			if(HighType==HT_KNOB) // can only be attached to highlighted root
			if(root(HighItem.k)!=drag.k) { // cannot be attached to child knob
				knob *k,*hk;
				k=drag.k;
				hk=HighItem.k;
				if(MessageBoxEx(hwnd,"Graft knob onto part?","Decision time",MB_YESNO,0)!=IDNO) {
					if(k==NULL) ReportSystemError("k==NULL");
					ReplaceKnob(k,hk);
					DestroyKnob(k,FALSE);
				}
			}
			RebuildPartMatrices();
			SetMouseMode(MM_NOTHING);
			ReleaseCapture();
			drag.k=NULL;
//			RebuildAllMatrices(NULL);
			InvalidateView();
		break;
	}
}

void RightRelease(HWND hwnd,WPARAM wParam,LPARAM lParam) {

	if(ActiveProject==NULL) return;

	rX=lX=LOWORD(lParam);
	rY=lY=HIWORD(lParam);
	switch(ActiveProject->EditMode|MouseMode) {
		case EM_MESHEDIT|MM_GRABVERX:
			SetMouseMode(MM_NOTHING);
		break;
		case EM_MESHEDIT|MM_DBLCLICX:
			SetMouseMode(MM_NOTHING);
		break;
		case EM_MESHEDIT|MM_HOOKVERX:
			SetMouseMode(MM_NOTHING);
		break;
		case EM_MESHEDIT|MM_RIGHTDOWN:
			SetMouseMode(MM_NOTHING);
			CheckHighlight(HT_CLEAR|HT_VERT|HT_KNOB|HT_EDGE|HT_PART|HT_FACE);
			Popup=TRUE;
			ReleaseCapture();
		break;
		case EM_MAPEDIT|MM_RIGHTDOWN:
			SetMouseMode(MM_NOTHING);
			CheckHighlight(HT_CLEAR|HT_UVPT);
			Popup=TRUE;
			ReleaseCapture();
		break;
		case EM_MESHEDIT|MM_DRAGKNOBX:
			drag.k=NULL;
			anch.k=NULL;
			SetMouseMode(MM_NOTHING);
			BlankSelection();
			InvalidateView();
		break;
		case EM_MESHEDIT|MM_ADDPARTX:
			drag.k=NULL;
			anch.k=NULL;
			SetMouseMode(MM_ADDPART0);
			BlankSelection();
			InvalidateView();
		break;
		case EM_MESHEDIT|MM_ADDMESHX:
			drag.v=NULL;
			anch.v=NULL;
			SetMouseMode(MM_ADDMESH0);
			BlankSelection();
			InvalidateView();
		break;
	}
}

void ClearHighlight(void) {
	HighType=HT_NOTHING;
	HighItem.v=NULL;
}

void ClearAllDragging(void) {
	MYPTR mp;

	STEPPARTS(ActiveProject,mp.p) mp.p->Flags&=~TF_DRAGGED;
	STEPVERTS(ActiveProject,mp.v) mp.v->Flags&=~TF_DRAGGED;
	STEPKNOBS(ActiveProject,mp.k) mp.k->Flags&=~TF_DRAGGED;
	STEPEDGES(ActiveProject,mp.e) mp.e->Flags&=~TF_DRAGGED;
	STEPFACES(ActiveProject,mp.f) mp.f->Flags&=~TF_DRAGGED;
}

void PrepSingleKnobDrag(knob* k) {
	knob *k1,*k2;

	ClearAllDragging();

	k->Flags|=TF_DRAGGED;

// get the inverse; we'll need it
	getEndInversion(k,iem);
	if(k->Owner) {
		getBaseInversion(k,ibm);
//		k->Owner->Rise->Flags|=TF_DRAGGED;
	}

// mark all dependent knobs for dragging
	STEPKNOBS(ActiveProject,k1)
	if(k1->Owner!=NULL) {
		k2=k1->Owner->Base;
		while(k2!=NULL) {
			if(k2==k) k1->Flags|=TF_DRAGGED;
			if(k2->Owner) {
				if(k2->Owner->Rise==k) k1->Flags|=TF_DRAGGED;
				k2=k2->Owner->Base;
			} else {
				k2=NULL;
			}
		}
	}

	FinishKnobDrag();
}

void FinishKnobDrag(void) {
	knob* k;
	part* p;
	vert* v;

	STEPPARTS(ActiveProject,p)
	if((p->End->Flags|p->Rise->Flags)&TF_DRAGGED)
	p->Flags|=TF_DRAGGED;

	STEPKNOBS(ActiveProject,k)
	if(k->Flags&TF_DRAGGED) {
		k->Save[X]=k->Spot[X];
		k->Save[Y]=k->Spot[Y];
		k->Save[Z]=k->Spot[Z];
	}

	STEPVERTS(ActiveProject,v)
	if(v->Owner)
	v->Flags|=(v->Owner->Flags&TF_DRAGGED);

	FinishVertDrag();
}

void PrepVertDrag(void) {
	vert* v;

	ClearAllDragging();

	STEPVERTS(ActiveProject,v)
	if(v->Flags&TF_MARKED)
	v->Flags|=TF_DRAGGED;

	FinishVertDrag();
}

void PrepSingleVertDrag(vert* v) {

	ClearAllDragging();

	v->Flags|=TF_DRAGGED;

	FinishVertDrag();
}

void FinishVertDrag(void) {
	MYPTR mp;

	STEPEDGES(ActiveProject,mp.e)
	if((mp.e->VertS->Flags|mp.e->VertE->Flags)&TF_DRAGGED)
	mp.e->Flags|=TF_DRAGGED;

	STEPVERTS(ActiveProject,mp.v)
	if(mp.v->Flags&TF_DRAGGED) {
		mp.v->Save[X]=mp.v->Spot[X];
		mp.v->Save[Y]=mp.v->Spot[Y];
		mp.v->Save[Z]=mp.v->Spot[Z];
	}

	STEPFACES(ActiveProject,mp.f)
	if(mp.f->VertD) {
		if((mp.f->VertA->Flags|mp.f->VertB->Flags|mp.f->VertC->Flags|mp.f->VertD->Flags)&TF_DRAGGED)
		mp.f->Flags|=TF_DRAGGED;
	} else {
		if((mp.f->VertA->Flags|mp.f->VertB->Flags|mp.f->VertC->Flags)&TF_DRAGGED)
		mp.f->Flags|=TF_DRAGGED;
	}
}

void AttachHighlight(BOOL dummy) {
	switch(HighType) {
		case HT_VERT:
			SetMouseMode(MM_HOOKHIGH);
			drag.v=HighItem.v;
		break;
	}
}

void SetMouseMode(short nm) {
	char *s;

	MouseMode=nm;

	s="";//"String not defined.";
	switch(nm) {
		case MM_NOTHING:	s="Select mode";	break;
		case MM_PANVIEW0:
		case MM_PANVIEW1:
			s="Left-click and drag to drag the view";
		break;
		case MM_ZOOMVIEW0:
		case MM_ZOOMVIEW1:
			s="Left-click and drag to zoom the view";
		break;
		case MM_ROTVIEW0:
		case MM_ROTVIEW1:
			s="Left-click and drag to rotate the view";
		break;
		case MM_ADDMESH0:
		case MM_ADDMESH1:
		case MM_ADDMESH2:	s="Adding mesh";	break;
		case MM_ADDVERT:	s="Click to add vertices";	break;
		case MM_ADDPART0:
		case MM_ADDPART1:
		case MM_ADDPART2:	s="Adding parts";	break;
	}
	UpdateStatusBar(s,0,0);
	UpdateToolBar();
}

void CheckHighlight(short flags) {
	GLuint *selbuff;
	GLint vp[4];
	short NewType,HitType;
	MYPTR NewItem;
	INDEX i,j;
	MYPTR m;
	UINT hits;
	unsigned int cmin,hmin,cmax,hmax;
	unsigned int skip;
	char buff[128];

	if(ActiveProject==NULL) return;

// make space for the select buffer
	selbuff=(GLuint *)malloc(SELBUFFSIZE*sizeof(GLuint));

	if(selbuff==NULL) {
		ReportSystemError("Selection buffer malloc() failed.");
		return;
	}

// clear out or preserve current highlight, depending on what's needed
	if(flags&HT_CLEAR) { // discard if not the current item
		NewType=HT_NOTHING;
		NewItem.e=NULL;
	} else { // discard only if replaced by another
		NewType=HighType;
		NewItem.e=HighItem.e;
	}

// set up select mode
// prepare the selection buffer
	glSelectBuffer(SELBUFFSIZE,selbuff);

// get the viewport
	glGetIntegerv(GL_VIEWPORT,vp);

// now go into projection mode
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
// set up clipping region
	glLoadIdentity();
	gluPickMatrix((GLdouble)lX,(GLdouble)(vp[3]+vp[1]-lY+ActiveProject->cView.Screen.top),(GLdouble)5,(GLdouble)5,vp);
	loadIntoOpenGL(&ActiveProject->cView,vp[2],vp[3]);

// go into selection mode
	glRenderMode(GL_SELECT);

// prepare name stack
	glInitNames();
	glPushName((GLuint)0);

// search faces
	if(((flags&HT_FACE)!=0) && ((ActiveProject->Flags&MF_SHOWFACES)!=0)) {
		glLoadName((GLuint)HT_FACE);
		glPushName((GLuint)0);
		STEPFACES(ActiveProject,m.f) {
			glLoadName((GLuint)m.f);
// render the face
			glBegin(GL_POLYGON);
			glVertex3fv((GLfloat*)&m.f->VertA->Spot);
			glVertex3fv((GLfloat*)&m.f->VertB->Spot);
			glVertex3fv((GLfloat*)&m.f->VertC->Spot);
			if(m.f->VertD) glVertex3fv((GLfloat*)&m.f->VertD->Spot);
			glEnd();
		}
		glPopName();
	}

// search edges
	if(((flags&HT_EDGE)!=0) && ((ActiveProject->Flags&MF_SHOWEDGES)!=0)) {
		glLoadName((GLuint)HT_EDGE);
		glPushName((GLuint)0);
		STEPEDGES(ActiveProject,m.e) {
			glLoadName((GLuint)m.e);
// render the edge
			glBegin(GL_LINES);
			glVertex3fv((GLfloat*)&m.e->VertS->Spot);
			glVertex3fv((GLfloat*)&m.e->VertE->Spot);
			glEnd();
		}
		glPopName();
	}

// search vertices
	if(((flags&HT_VERT)!=0) && ((ActiveProject->Flags&MF_SHOWVERTS)!=0)) {
		glLoadName((GLuint)HT_VERT);
		glPushName((GLuint)0);
		STEPVERTS(ActiveProject,m.v)
		if(m.v!=drag.v) {
			glLoadName((GLuint)m.v);
// render the vertex
            glBegin(GL_POINTS);
			glVertex3fv((GLfloat *)&m.v->Spot);
			glEnd();
		}
		glPopName();
	}

	if((flags&HT_UVPT)!=0) {
		glLoadName((GLuint)HT_UVPT);
		glPushName((GLuint)0);
		STEPUVPTS(ActiveProject,m.u)
		if(m.u!=drag.u) {
			glLoadName((GLuint)m.u);
// render the uv point
            glBegin(GL_POINTS);
			glVertex2fv((GLfloat *)&m.u->Spot);
			glEnd();
		}
		glPopName();
	}

// search parts
	if(((flags&HT_PART)!=0) && ((ActiveProject->Flags&MF_SHOWPARTS)!=0)) {
		glLoadName((GLuint)HT_PART);
		glPushName((GLuint)0);
		STEPPARTS(ActiveProject,m.p) {
			glLoadName((GLuint)m.p);
// render the part
			glBegin(GL_LINES);
			glVertex3fv((GLfloat*)&m.p->Base->Spot);
			glVertex3fv((GLfloat*)&m.p->End->Spot);
			glVertex3f( m.p->Base->Spot[X]*.25 + m.p->End->Spot[X]*.75,
				m.p->Base->Spot[Y]*.25 + m.p->End->Spot[Y]*.75,
				m.p->Base->Spot[Z]*.25 + m.p->End->Spot[Z]*.75 );
			glVertex3fv((GLfloat*)&m.p->Rise->Spot);
			glEnd();
		}
		glPopName();
	}

// search knobs
	if(((flags&HT_KNOB)!=0) && ((ActiveProject->Flags&MF_SHOWPARTS)!=0)) {
		glLoadName((GLuint)HT_KNOB);
		glPushName((GLuint)0);
		STEPKNOBS(ActiveProject,m.k)
		if(m.k!=drag.k)
		if(((flags&HT_NORISE)==0) || ((m.k->Flags&KF_ISRISE)==0))  {
			glLoadName((GLuint)m.k);
// render the knob
            glBegin(GL_POINTS);
			glVertex3fv((GLfloat *)&m.k->Spot);
			glEnd();
		}
		glPopName();
	}

	glPopName();

	hits=glRenderMode(GL_RENDER);

	hmin=0xffffffff;
	hmax=0xffffffff;

	j=0;
	HitType=HT_NOTHING;
	while(hits>0 && j<SELBUFFSIZE) {
		skip=selbuff[j++];	// get count of names
		cmin=selbuff[j++];	// get shallow end of hit
	    cmax=selbuff[j++];	// get deep end of hit
		while(skip) {
			if((selbuff[j]>(UINT)HitType && cmin<=hmax && cmax>=hmin) // overlapped by higher priority item
			|| cmax<hmin ) { // closer item found
				HitType=(short)selbuff[j];
				i=selbuff[j+1];
				hmin=cmin;
				hmax=cmax;
			}
			j+=2;
			skip-=2;
		}
		hits--;
	}

	if(HitType!=HT_NOTHING) {
		NewItem.u=(uvpt*)i;
		NewType=HitType;
	}

	HighType=NewType;
	HighItem.e=NewItem.e;
	if(HighItem.e==NULL) HighType=HT_NOTHING;

// restore old viewing matrix
	glPopName();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	free(selbuff);

	switch(HighType) {
	case HT_PART:
		if(HighItem.p->Name!=NULL)
		switch(HighItem.p->Flags&PT_MASK) {
			case PT_UNI:
				sprintf(buff,"Uni joint: %s",HighItem.p->Name);
			break;
			case PT_BALL:
				sprintf(buff,"Ball joint: %s",HighItem.p->Name);
			break;
			case PT_HINGE:
				sprintf(buff,"Hinge joint: %s",HighItem.p->Name);
			break;
		}
		UpdateStatusBar(buff,0,0);
	break;
	case HT_VERT:
		if(HighItem.v->Flags&VF_LOCKED) {
			UpdateStatusBar("This vertex is locked",0,0);
		} else {
			UpdateStatusBar("",0,0);
		}
	break;
	case HT_EDGE:
		if(HighItem.e->Flags&TF_SHARP) {
			UpdateStatusBar("This edge is sharp",0,0);
		} else {
			UpdateStatusBar("",0,0);
		}
	break;
	default:
			UpdateStatusBar("",0,0);
	break;
	}
	InvalidateView();

}

void CheckSelectBox(RECT *box,short flags) {
	GLuint *selbuff;
	GLint vp[4];
	INDEX j;
	MYPTR m;
	UINT hits;
	unsigned int skip;

	if(ActiveProject==NULL) return;

// make space for the select buffer
	selbuff=(GLuint *)malloc(SELBUFFSIZE*sizeof(GLuint));

	if(selbuff==NULL) {
		ReportSystemError("Selection buffer malloc() failed.");
		return;
	}

// set up select mode
// prepare the selection buffer
	glSelectBuffer(SELBUFFSIZE,selbuff);

// get the viewport
	glGetIntegerv(GL_VIEWPORT,vp);

// now go into projection mode
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
// set up clipping region
	glLoadIdentity();
	gluPickMatrix(
		((GLdouble)box->left+(GLdouble)box->right)*.5,
		(GLdouble)vp[3]+(GLdouble)ActiveProject->cView.Screen.top+(GLdouble)vp[1]-((GLdouble)box->bottom+(GLdouble)box->top)*.5,
		(GLdouble)(box->right-box->left),
		(GLdouble)(box->bottom-box->top),
		vp);
	loadIntoOpenGL(&ActiveProject->cView,vp[2],vp[3]);

// go into selection mode
	glRenderMode(GL_SELECT);

// prepare name stack
	glInitNames();
// used by all objects
	glPushName((GLuint)0);

// search vertices
	if(((flags&HT_VERT)!=0) && ((ActiveProject->Flags&MF_SHOWVERTS)!=0)) {
		STEPVERTS(ActiveProject,m.v)
		if(m.v!=drag.v) {
			glLoadName((GLuint)m.v);
// render the vertex
            glBegin(GL_POINTS);
			glVertex3fv((GLfloat *)&m.v->Spot);
			glEnd();
		}
	}

	if((flags&HT_UVPT)!=0) {
		STEPUVPTS(ActiveProject,m.u)
		if(m.u!=drag.u) {
			glLoadName((GLuint)m.u);
// render the uv point
            glBegin(GL_POINTS);
			glVertex2fv((GLfloat *)&m.u->Spot);
			glEnd();
		}
	}

// done with pushed name
	glPopName();

	hits=glRenderMode(GL_RENDER);

	j=0;
	while(hits>0 && j<SELBUFFSIZE-4) {
		skip=selbuff[j];	// get count of names
		j+=3;	// skip name count and range of hit
		while(skip) {
			m.u=(uvpt*)selbuff[j++];
			m.u->Flags^=TF_MARKED;
			skip--;
		}
		hits--;
	}

// restore old viewing matrix
	glPopName();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	free(selbuff);
}
