#include "data.h"
#include <gl/gl.h>
#include <gl/glu.h>

HGLRC PrepareRenderingContext(HDC hdc) {
	HGLRC rc;
	HBITMAP hbr;
	PIXELFORMATDESCRIPTOR pfd;
	int pfi;
	BITMAP bi;

	static short flag1=0;

	hbr=(HBITMAP)GetCurrentObject(hdc,OBJ_BITMAP);
	GetObject(hbr,sizeof(BITMAP),&bi);

	memset(&pfd,0,sizeof(PIXELFORMATDESCRIPTOR));
	pfd.nSize=sizeof(PIXELFORMATDESCRIPTOR);
	pfd.nVersion=1;
	pfd.dwFlags=PFD_DRAW_TO_WINDOW|PFD_SUPPORT_OPENGL|PFD_DOUBLEBUFFER;
	pfd.iPixelType=PFD_TYPE_RGBA;
	pfd.cColorBits=bi.bmBitsPixel;
	pfd.cDepthBits=24;

	pfi=ChoosePixelFormat(hdc,&pfd);
	DescribePixelFormat(hdc,pfi,sizeof(PIXELFORMATDESCRIPTOR),&pfd);
	SetPixelFormat(hdc,pfi,&pfd);

	rc=wglCreateContext(hdc);

	if(rc==NULL) {
		if(flag1==0) {
			flag1=1;
			ReportSystemError("RC creation failed.");
		}
	}

	return rc;
}

void OpenGLError(void) {
	switch(glGetError()) {
	    case GL_INVALID_ENUM:
	    	UpdateStatusBar("GL_INVALID_ENUM",0,0);
	   	break;
	   	case GL_INVALID_OPERATION:
	   		UpdateStatusBar("GL_INVALID_OPERATION",0,0);
   		break;
   	}
}

 	
