#ifndef SKEL_H
#define SKEL_H

#include "calc.h"
#include "lists.h"

typedef struct {
	THINGMEMBERS
	vec	Spot,Save;
	struct Part *Owner;
} knob;

void getBaseMatrix(knob*,float*);
void getEndMatrix(knob*,float*);
void getBaseInversion(knob*,float*);
void getEndInversion(knob*,float*);
knob* root(knob*);

#define KF_ISBASE	16
#define KF_ISEND	32
#define KF_ISRISE	64

typedef struct Part {
	THINGMEMBERS
	knob*	Base,*End,*Rise;
	struct Part *Parent;
	matrix	mB,mE;
	range	AngleX;
	range	AngleY;
	range	AngleZ;
	range	Length;
	float	TwistCos,TwistSin;
	char	*Name;
} part;

void getInheritedMatrix(part*,float*);
void buildMatrices(part*,BOOL);

#define PF_LOCKX	16
#define PF_LOCKY	32
#define	PF_LOCKZ	64
#define	PF_LOCKL	128
#define PF_LOCKMASK	(PF_LOCKX|PF_LOCKY|PF_LOCKZ|PF_LOCKL)
#define PT_UNI  	0
#define PT_HINGE	256
#define	PT_BALL		512
#define PT_MASK		(PT_UNI|PT_HINGE|PT_BALL)

#endif

